/*
 * Copyright (C) 2005-2006 Kouji Sugisawa. All rights reserved.
 */

package jp.sourceforge.livez.dao;

import java.io.Serializable;
import java.util.Set;

import org.apache.commons.lang.StringUtils;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

/**
 * EZweb [񋟂܂B
 * 
 * @author V _
 */
public class EZweb implements Serializable {

	private static final long serialVersionUID = 1L;

	/**
	 * ftHgRXgN^łB
	 */
	public EZweb() {}

	/**
	 * foCXIDێ܂B
	 */
	private String deviceType;

	/**
	 * foCXID擾܂B
	 * 
	 * @return foCXID
	 */
	public String getDeviceType() {
		return deviceType;
	}

	/**
	 * foCXIDݒ肵܂B
	 * 
	 * @param deviceType foCXID
	 */
	public void setDeviceType(final String deviceType) {
		this.deviceType = StringUtils.defaultIfEmpty(deviceType, null);
	}

	/**
	 * @햼̂ێ܂B
	 */
	private String productName;

	/**
	 * @햼̂Ԃ܂B
	 * 
	 * @return @햼
	 */
	public String getProductName() {
		return productName;
	}

	/**
	 * @햼̂ݒ肵܂B
	 * 
	 * @param name @햼
	 */
	public void setProductName(final String name) {
		this.productName = StringUtils.defaultIfEmpty(name, null);
	}

	/**
	 * V[Yێ܂B
	 */
	private String seriesName;

	/**
	 * V[YԂ܂B
	 * 
	 * @return V[Y
	 */
	public String getSeriesName() {
		return seriesName;
	}

	/**
	 * V[Yݒ肵܂B
	 * 
	 * @param seriesName V[Y
	 */
	public void setSeriesName(final String seriesName) {
		this.seriesName = StringUtils.defaultIfEmpty(seriesName, null);
	}

	/**
	 * Ҏ󂯉ʂ̕ێ܂B
	 */
	private Integer screenWidth;

	/**
	 * Ҏ󂯉ʂ̕Ԃ܂B
	 * 
	 * @return Ҏ󂯉ʂ̕
	 */
	public Integer getScreenWidth() {
		return screenWidth;
	}

	/**
	 * Ҏ󂯉ʂ̕ݒ肵܂B
	 * 
	 * @param screenWidth Ҏ󂯉ʂ̕
	 */
	public void setScreenWidth(final Integer screenWidth) {
		if (screenWidth == null || screenWidth <= 0)
			this.screenWidth = null;
		else
			this.screenWidth = screenWidth;
	}

	/**
	 * Ҏ󂯉ʂ̍ێ܂B
	 */
	private Integer screenHeight;

	/**
	 * Ҏ󂯉ʂ̍Ԃ܂B
	 * 
	 * @return Ҏ󂯉ʂ̍
	 */
	public Integer getScreenHeight() {
		return screenHeight;
	}

	/**
	 * Ҏ󂯉ʂ̍Ԃ܂B
	 * 
	 * @param screenHeight Ҏ󂯉ʂ̍
	 */
	public void setScreenHeight(final Integer screenHeight) {
		if (screenHeight == null || screenHeight <= 0)
			this.screenHeight = null;
		else
			this.screenHeight = screenHeight;
	}

	/**
	 * GIF 摜Ή󋵂ێ܂B
	 */
	private boolean gif;

	/**
	 * GIF 摜Ή󋵂Ԃ܂B
	 * 
	 * @return GIF 摜Ή
	 */
	public boolean isGif() {
		return gif;
	}

	/**
	 * GIF 摜Ή󋵂ݒ肵܂B
	 * 
	 * @param gif GIF 摜Ή
	 */
	public void setGif(final boolean gif) {
		this.gif = gif;
	}

	/**
	 * JPEG 摜Ή󋵂ێ܂B
	 */
	private boolean jpeg;

	/**
	 * JPEG 摜Ή󋵂Ԃ܂B
	 * 
	 * @return JPEG 摜Ή
	 */
	public boolean isJpeg() {
		return jpeg;
	}

	/**
	 * JPEG 摜Ή󋵂ݒ肵܂B
	 * 
	 * @param jpeg JPEG 摜Ή
	 */
	public void setJpeg(final boolean jpeg) {
		this.jpeg = jpeg;
	}

	/**
	 * 256F PNG 摜Ή󋵂ێ܂B
	 */
	private boolean png8bit;

	/**
	 * 256F PNG 摜Ή󋵂Ԃ܂B
	 * 
	 * @return 256F PNG 摜Ή
	 */
	public boolean isPng8bit() {
		return png8bit;
	}

	/**
	 * 256F PNG 摜Ή󋵂ݒ肵܂B
	 * 
	 * @param png8bit 256F PNG 摜Ή
	 */
	public void setPng8bit(final boolean png8bit) {
		this.png8bit = png8bit;
	}

	/**
	 * J[ BMP 摜Ή󋵂ێ܂B
	 */
	private boolean bmp2bit;

	/**
	 * J[ BMP 摜Ή󋵂Ԃ܂B
	 * 
	 * @return J[ BMP 摜Ή
	 */
	public boolean isBmp2bit() {
		return bmp2bit;
	}

	/**
	 * J[ BMP 摜Ή󋵂ݒ肵܂B
	 * 
	 * @param bmp2bit J[ BMP 摜Ή
	 */
	public void setBmp2bit(final boolean bmp2bit) {
		this.bmp2bit = bmp2bit;
	}

	/**
	 *  BMP 摜Ή󋵂ێ܂B
	 */
	private boolean bmp1bit;

	/**
	 *  BMP 摜Ή󋵂Ԃ܂B
	 * 
	 * @return  BMP 摜Ή
	 */
	public boolean isBmp1bit() {
		return bmp1bit;
	}

	/**
	 *  BMP 摜Ή󋵂ݒ肵܂B
	 * 
	 * @param bmp1bit  BMP 摜Ή
	 */
	public void setBmp1bit(final boolean bmp1bit) {
		this.bmp1bit = bmp1bit;
	}

	/**
	 * ʐ^t[̃Xgێ܂B
	 */
	private Set<EZwebFrame> frames;

	/**
	 * ʐ^t[̃XgԂ܂B
	 * 
	 * @return ʐ^t[̃Xg
	 */
	public Set<EZwebFrame> getFrames() {
		return frames;
	}

	/**
	 * ʐ^t[̃Xgݒ肵܂B
	 * 
	 * @param frames ʐ^t[̃Xg
	 */
	public void setFrames(final Set<EZwebFrame> frames) {
		this.frames = frames;
	}

	/**
	 * ʐ^X^vێ܂B
	 */
	private EZwebStamp stamp;

	/**
	 * ʐ^X^vԂ܂B
	 * 
	 * @return ʐ^X^v
	 */
	public EZwebStamp getStamp() {
		return stamp;
	}

	/**
	 * ʐ^X^vݒ肵܂B
	 * @param stamp
	 */
	public void setStamp(final EZwebStamp stamp) {
		this.stamp = stamp;
	}

	@Override
	public int hashCode() {
		return HashCodeBuilder.reflectionHashCode(this);
	}

	@Override
	public boolean equals(final Object obj) {
		return EqualsBuilder.reflectionEquals(this, obj);
	}

	@Override
	public String toString() {
		return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
	}

}
