/*
 * Copyright (C) 2005-2006 Kouji Sugisawa. All rights reserved.
 */

package jp.sourceforge.livez.dao.hibernate;

import java.util.List;

import org.hibernate.LockMode;
import org.hibernate.Query;
import org.springframework.dao.DataAccessException;
import org.springframework.orm.ObjectRetrievalFailureException;
import org.springframework.orm.hibernate3.HibernateTemplate;
import org.springframework.orm.hibernate3.support.HibernateDaoSupport;

import jp.sourceforge.livez.dao.Vodafone;

/**
 * VodafoneDAO  Hibernate 3 ŎNXłB
 * 
 * @author V _
 */
public final class VodafoneDaoImpl extends HibernateDaoSupport implements jp.sourceforge.livez.dao.VodafoneDAO {

	/**
	 * ftHgRXgN^łB
	 */
	public VodafoneDaoImpl() {}

	/*
	 * @see jp.sourceforge.livez.dao.VodafoneDAO#loadAll()
	 */
	@SuppressWarnings("unchecked")
	public List<Vodafone> loadAll() throws DataAccessException {
		HibernateTemplate template = getHibernateTemplate();
		return template.loadAll(Vodafone.class);
	}

	/*
	 * @see jp.sourceforge.livez.dao.VodafoneDAO#load(java.lang.String)
	 */
	public Vodafone load(final String name) throws DataAccessException {
		try {
			return (Vodafone) getHibernateTemplate().load(Vodafone.class, name);
		} catch (ObjectRetrievalFailureException e) {
			return null;
		}
	}

	/*
	 * @see jp.sourceforge.livez.dao.VodafoneDAO#save(jp.sourceforge.livez.dao.Vodafone)
	 */
	public void save(final Vodafone vodafone) throws DataAccessException {
		HibernateTemplate template = getHibernateTemplate();
		template.save(vodafone);
	}

	/*
	 * @see jp.sourceforge.livez.dao.VodafoneDAO#update(jp.sourceforge.livez.dao.Vodafone, java.lang.String)
	 */
	public void update(final Vodafone vodafone, final String name) throws DataAccessException {
		if (!name.equals(vodafone.getName())) {
			Query query = getSession().createQuery("UPDATE Vodafone SET name = ? WHERE name = ?");
			query.setString(0, vodafone.getName());
			query.setString(1, name);
			query.executeUpdate();
		}

		HibernateTemplate template = getHibernateTemplate();
		template.update(vodafone, LockMode.UPGRADE_NOWAIT);
	}

	/*
	 * @see jp.sourceforge.livez.dao.VodafoneDAO#delete(java.lang.String)
	 */
	public void delete(final String name) throws DataAccessException {
		HibernateTemplate template = getHibernateTemplate();
		Vodafone vodafone = (Vodafone) template.load(Vodafone.class, name);
		template.delete(vodafone, LockMode.UPGRADE_NOWAIT);
	}

}
