/*
 * Copyright (C) 2005-2006 Kouji Sugisawa. All rights reserved.
 */

package jp.sourceforge.livez.dao.ibatis;

import java.util.HashSet;
import java.util.Iterator;
import java.util.List;

import org.springframework.dao.DataAccessException;
import org.springframework.orm.ibatis.SqlMapClientTemplate;
import org.springframework.orm.ibatis.support.SqlMapClientDaoSupport;

import jp.sourceforge.livez.dao.EZweb;
import jp.sourceforge.livez.dao.EZwebFrame;
import jp.sourceforge.livez.dao.EZwebStamp;

/**
 * EZwebDAO  iBATIS ŎNXłB
 * 
 * @author V _
 */
public final class EZwebDaoImpl extends SqlMapClientDaoSupport implements jp.sourceforge.livez.dao.EZwebDAO {

	/**
	 * ftHgRXgN^łB
	 */
	public EZwebDaoImpl() {}

	/*
	 * @see jp.sourceforge.livez.dao.EZwebDAO#loadAll()
	 */
	@SuppressWarnings("unchecked")
	public List<EZweb> loadAll() throws DataAccessException {
		SqlMapClientTemplate template = getSqlMapClientTemplate();

		List list = template.queryForList("livez.listEZweb", null);

		for (int i = 0; i < list.size(); i++)
			loadChild((EZweb)list.get(i));

		return list;
	}

	/*
	 * @see jp.sourceforge.livez.dao.EZwebDAO#load(java.lang.String)
	 */
	@SuppressWarnings("unchecked")
	public EZweb load(final String deviceType) throws DataAccessException {
		SqlMapClientTemplate template = getSqlMapClientTemplate();
		EZweb ezweb = (EZweb) template.queryForObject("livez.getEZweb", deviceType);

		if (ezweb != null)
			loadChild(ezweb);

		return ezweb;
	}

	@SuppressWarnings("unchecked")
	private void loadChild(final EZweb ezweb) throws DataAccessException {
		SqlMapClientTemplate template = getSqlMapClientTemplate();
		String deviceType = ezweb.getDeviceType();

		ezweb.setStamp((EZwebStamp) template.queryForObject("livez.getEZwebStamp", deviceType));
		ezweb.setFrames(new HashSet(template.queryForList("livez.getEZwebFrame", deviceType)));
	}

	/*
	 * @see jp.sourceforge.livez.dao.EZwebDAO#save(jp.sourceforge.livez.dao.EZweb)
	 */
	public void save(final EZweb ezweb) throws DataAccessException {
		SqlMapClientTemplate template = getSqlMapClientTemplate();
		template.insert("livez.saveEZweb", ezweb);

		if (ezweb.getStamp() != null)
			template.insert("livez.saveEZwebStamp", ezweb.getStamp());

		if (ezweb.getFrames() != null) {
			Iterator<EZwebFrame> iterator = ezweb.getFrames().iterator();
			while (iterator.hasNext()) {
				EZwebFrame frame = iterator.next();
				template.insert("livez.saveEZwebFrame", frame);
			}
		}
	}

	/*
	 * @see jp.sourceforge.livez.dao.EZwebDAO#update(jp.sourceforge.livez.dao.EZweb, java.lang.String)
	 */
	public void update(final EZweb ezweb, final String deviceType) throws DataAccessException {
		delete(deviceType);
		save(ezweb);
	}

	/*
	 * @see jp.sourceforge.livez.dao.EZwebDAO#delete(java.lang.String)
	 */
	public void delete(final String deviceType) throws DataAccessException {
		SqlMapClientTemplate template = getSqlMapClientTemplate();
		template.update("livez.deleteEZweb", deviceType);
	}

}
