package jp.sourceforge.livez.pages;

import org.cyberneko.html.filters.ElementRemover;

final class ElementFilter extends ElementRemover {

	public ElementFilter() {
		super();

		acceptElement("a",			new String[] { "name", "href", "accesskey" });
		acceptElement("abbr",		null);
		acceptElement("acronym",	null);
		acceptElement("address",	null);
//		removeElement("applet");
		acceptElement("area",		new String[] { "href", "alt", "accesskey" });
		acceptElement("b",			null);
		removeElement("base");
		// basefont
		// bdo
		acceptElement("bgsound",	null);
		acceptElement("big",		null);
		acceptElement("blink",		null);
		acceptElement("blockquote",	null);
		acceptElement("body",		new String[] { "text", "link", "alink", "vlink", "bgcolor", "background" });
		acceptElement("br",			new String[] { "clear" });
		acceptElement("button",		new String[] { "type" });
		acceptElement("caption",	new String[] { "align" });
		acceptElement("center",		null);
		acceptElement("cite",		null);
		acceptElement("code",		null);
		// col
		// colgroup
		acceptElement("comment",	null);
		acceptElement("dd",			null);
		removeElement("del");
		acceptElement("dfn",		null);
		acceptElement("dir",		new String[] { "type" });
		acceptElement("div",		new String[] { "align" });
		acceptElement("dl",			null);
		acceptElement("dt",			null);
		acceptElement("em",			null);
//		removeElement("embed");
		acceptElement("fieldset",	null);
		acceptElement("font",		new String[] { "color", "size" });
		acceptElement("form",		new String[] { "action", "method", "utn" });
		removeElement("frame");
		removeElement("frameset");
		acceptElement("h1",			new String[] { "align" });
		acceptElement("h2",			new String[] { "align" });
		acceptElement("h3",			new String[] { "align" });
		acceptElement("h4",			new String[] { "align" });
		acceptElement("h5",			new String[] { "align" });
		acceptElement("h6",			new String[] { "align" });
		removeElement("head");
		acceptElement("hr",			new String[] { "size", "color", "width", "align", "noshade" });
		// html
		acceptElement("i",			null);
		acceptElement("iframe",		null);
		acceptElement("ilayer",		null);
		acceptElement("img",		new String[] { "src", "width", "height", "align", "hspace", "vspace", "alt" });
		acceptElement("input",		new String[] { "type", "name", "size", "maxlength", "value", "checked", "accesskey", "istyle" });
		acceptElement("ins",		null);
		acceptElement("isindex",	new String[] { "action", "prompt" });
		acceptElement("kbd",		null);
		// keygen
		acceptElement("label",		null);
		acceptElement("layer",		null);
		acceptElement("legend",		null);
		acceptElement("li",			new String[] { "type" });
		removeElement("link");
		acceptElement("listing",	null);
		// map
		acceptElement("marquee",	new String[] { "behavior", "direction", "loop", "bgcolor" });
		acceptElement("menu",		new String[] { "type" });
		removeElement("meta");
		// multicol
		removeElement("nextid");
		acceptElement("nobr",		null);
		// noembed
		removeElement("noframes");
		// nolayer
		// noscript
		acceptElement("object",		new String[] { "type" });
		acceptElement("ol",			new String[] { "type", "start" });
		acceptElement("option",		new String[] { "value", "selected" });
		// optgroup
		acceptElement("p",			new String[] { "align" });
		acceptElement("param",		new String[] { "name", "value", "valuetype" });
		acceptElement("plaintext",	null);
		acceptElement("pre",		null);
		acceptElement("q",			null);
		// rb
		// rp
		// rt
		// ruby
		removeElement("s");
		// samp
		removeElement("script");
		acceptElement("select",		new String[] { "name", "size", "multiple" });
		removeElement("server");
		acceptElement("small",		null);
		// spacer
		// span
		removeElement("strike");
		acceptElement("strong",		null);
		removeElement("style");
		// sub
		// sup
		acceptElement("table",		new String[] { "border", "bodercolor", "bgcolor", "width", "height", "align" });
		// tbody
		acceptElement("td",			new String[] { "rowspan", "colspan", "align", "valign", "width", "height", "bgcolor", "bordercolor" });
		acceptElement("textarea",	new String[] { "name", "rows", "cols", "accesskey", "istyle" });
		// tfoot
		acceptElement("th",			new String[] { "rowspan", "colspan", "align", "valign", "width", "height", "bgcolor", "bordercolor" });
		// thead
		removeElement("title");
		acceptElement("tr",			new String[] { "align", "valign", "bgcolor", "bordercolor" });
		// tt
		acceptElement("u",			null);
		acceptElement("ul",			new String[] { "type" });
		// var
		// wbr
		acceptElement("xmp",		null);
	}

}
