/*
 * Copyright (C) 2006 Kouji Sugisawa. All rights reserved.
 */

package jp.sourceforge.livez.pages;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;

import org.apache.commons.io.IOUtils;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

/**
 * w肳ꂽ\[XRec擾NXłB
 * \[X HTML ł邱ƂOɏ܂B
 * 
 * @author V _
 */
final class FramePageConverter {

	/**
	 * CX^XłȂ܂B
	 */
	private FramePageConverter() {}

	public static String convert(final byte[] bytes, final String encoding) throws IOException, SAXException {
		InputStream in = new ByteArrayInputStream(bytes);
		try {
			return convert(in, encoding);
		} finally {
			IOUtils.closeQuietly(in);
		}
	}

	private static String convert(final InputStream in, final String encoding) throws IOException, SAXException {
		InputSource input = new InputSource(in);
		if (encoding != null)
			input.setEncoding(encoding);
		return convert(input);
	}

	private static String convert(final InputSource input) throws IOException, SAXException {
		FramePageHandler handler = new FramePageHandler();
		HTMLParser.parse(input, handler, null);
		return handler.getPage();
	}

}
