/*
 * Copyright (C) 2006 Kouji Sugisawa. All rights reserved.
 */

package jp.sourceforge.livez.pages;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.URL;

import org.apache.commons.io.IOUtils;
import org.apache.xerces.xni.parser.XMLDocumentFilter;
import org.cyberneko.html.filters.ElementRemover;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

import jp.sourceforge.livez.pages.HTMLParser;

/**
 * w肳ꂽ\[Xt[x̃tbgsNXłB
 * \[X HTML ł邱ƂOɏ܂B
 * 
 * @author V _
 */
final class FrameSetConverter {

	private static final ElementRemover remover = new ElementRemover();

	static {
		remover.acceptElement("frame", new String[] { "src", "name" });
	}

	/**
	 * CX^XłȂ܂B
	 */
	private FrameSetConverter() {}

	public static String convert(final byte[] bytes, final String encoding, final URL base, final HTMLOverview header) throws IOException, SAXException {
		InputStream in = new ByteArrayInputStream(bytes);
		try {
			return convert(in, encoding, base, header);
		} finally {
			IOUtils.closeQuietly(in);
		}
	}

	private static String convert(final InputStream in, final String encoding, final URL base, final HTMLOverview header) throws IOException, SAXException {
		InputSource input = new InputSource(in);

		if (encoding != null)
			input.setEncoding(encoding);

		return convert(input, base, header);
	}

	private static String convert(final InputSource input, final URL base, final HTMLOverview header) throws IOException, SAXException {
		FrameSetHandler handler = new FrameSetHandler(base, header);
		HTMLParser.parse(input, handler, new XMLDocumentFilter[] { remover });
		return handler.getPage();
	}

}
