/*
 * Copyright (C) 2006 Kouji Sugisawa. All rights reserved.
 */

package jp.sourceforge.livez.pages;

import java.io.IOException;

import org.apache.xerces.xni.parser.XMLDocumentFilter;
import org.cyberneko.html.parsers.SAXParser;
import org.xml.sax.ContentHandler;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.SAXNotRecognizedException;
import org.xml.sax.SAXNotSupportedException;
import org.xml.sax.XMLReader;

final class HTMLParser {

	/**
	 * CX^XłȂ܂B
	 */
	private HTMLParser() {}

	public static final void parse(
		final InputSource input,
		final ContentHandler handler,
		final XMLDocumentFilter[] filters)
		throws IOException, SAXException {

		XMLReader reader = createXMLReader(filters);
		reader.setContentHandler(handler);
//		if (handler instanceof AbstractBodyHandler)
			reader.setProperty("http://xml.org/sax/properties/lexical-handler", handler);
		reader.parse(input);
	}

	private static XMLReader createXMLReader(final XMLDocumentFilter[] filters) throws SAXNotRecognizedException, SAXNotSupportedException {
		XMLReader reader;

		reader = new SAXParser();

//		reader.setFeature("http://cyberneko.org/html/features/scanner/cdata-sections", true);
//		reader.setFeature("http://cyberneko.org/html/features/scanner/notify-builtin-refs", true);
//		reader.setFeature("http://cyberneko.org/html/features/scanner/fix-mswindows-refs", true);
//		reader.setFeature("http://cyberneko.org/html/features/scanner/script/strip-comment-delims", true);
//		reader.setFeature("http://cyberneko.org/html/features/scanner/script/strip-cdata-delims", true);
//		reader.setFeature("http://cyberneko.org/html/features/scanner/style/strip-comment-delims", false);
//		reader.setFeature("http://cyberneko.org/html/features/scanner/style/strip-cdata-delims", false);

		reader.setProperty("http://cyberneko.org/html/properties/filters", filters);
		reader.setProperty("http://cyberneko.org/html/properties/default-encoding", "Windows-31J");
		reader.setProperty("http://cyberneko.org/html/properties/names/elems", "lower");
		reader.setProperty("http://cyberneko.org/html/properties/names/attrs", "lower");

		return reader;
	}

}
